%% Collects simulations results

clear
result_indicies=[22:24 30:33 38:39 102:110 125:144 157:206 211:230 231 236:238 240:251];
 
J_size_store= zeros(length(result_indicies),1);
initial_eff_F= zeros(length(result_indicies),1);
J_post_eff_F10_store= zeros(length(result_indicies),1);
share_F10_store = zeros(length(result_indicies),1);
%%
for count=1:length(result_indicies)
    specid=num2str(result_indicies(count));
    loadname=strcat('simulation_eff_F/spec',specid);
    load(loadname);
    t_size_5(count,:)=q';
    ar_size_5(count,:)=n';
  
    median_t_bias(count,:)=u';  
    initial_F(count,:)=i(1);
    
    %% import simulation results drawn directly from reported estimates
    t_size0_5(count,:)=q0';
 
    ar_size0_5(count,:)=n0';
 
    median_t_bias0(count,:)=u0';
    
    t_size_postF_5(count,:)=b_eff_F10';
    twostep_size_5(count,:)=e_eff_F10';
    t_size_postF0_5(count,:)=t_post_eff_F10';
    twostep_size0_5(count,:)=twostep_eff_F10';
    initial_eff_F(count,:)=initial_eff_f;
 
    twostep_size_eff_F5(count,:)=twostep_eff_F5;
    twostep_size_eff_F10(count,:)=twostep_eff_F10;
    twostep_size_eff_F15(count,:)=twostep_eff_F15;
    twostep_size_eff_F20(count,:)=twostep_eff_F20;
    twostep_size_eff_F_crit5(count,:)=twostep_eff_F_crit5;
    twostep_size_eff_F_crit10(count,:)=twostep_eff_F_crit10;
    
        K_store(count,:)=k;
 
    if k > 1
        J_size_store(count,:)=J_size;
        initial_eff_F(count,:)=initial_eff_f;
        J_post_eff_F10_store(count,:)=J_post_eff_F10;
        share_F10_store(count,:)=share_F10;

    end
end

 
initial_eff_F = initial_eff_F+1;
 
%%
figure(1)
bias_median=median_t_bias0;
bias_upper=quantile(median_t_bias,.95,2);
bias_lower=quantile(median_t_bias,.05,2);


fig=figure(1);
title('Median t-Statistic')
set(fig,'position',[0,0,700,230])
subplot(1,3,1)
scatter(initial_eff_F,bias_median,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Median t-Statistic')
hline = refline([0 0]);
line([10 10],[-1.96 1.96],'Color','r');
ylim([-1.96 1.96])
xlim([0 50])
subplot(1,3,2)
scatter(initial_eff_F,bias_lower,20,'^k','filled')
xlabel('Average Effective F-Statistic')
ylabel('5th Percentile of Median t-Statistic')
hline = refline([0 0]);
line([10 10],[-1.96 1.96],'Color','r');
ylim([-1.96 1.96])
xlim([0 50])
subplot(1,3,3)
scatter(initial_eff_F,bias_upper,20,'vk','filled')
xlabel('Average Effective F-Statistic')
ylabel('95th Percentile of Median t-Statistic')
hline = refline([0 0]);
line([10 10],[-1.96 1.96],'Color','r');
ylim([-1.96 1.96])
xlim([0 50])



figurename = strcat('figures/median_t_bias_errorbar_t_effF',  '.eps')

%print(figurename,'-depsc')
%%
figure(2)
t_mean=t_size0_5;
t_upper=quantile(t_size_5,.95,2);
t_lower=quantile(t_size_5,.05,2);

fig=figure(2);
set(fig,'position',[0,0,700,230])
subplot(1,3,1)
scatter(initial_eff_F,t_mean,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% t-Test')
hline = refline([0 0.05]);
line([10 10],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])
subplot(1,3,2)
scatter(initial_eff_F,t_lower,20,'^k','filled')
xlabel('Average Effective F-Statistic')
ylabel('5th Percentile of Size')
hline = refline([0 0.05]);
line([10 10],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])
subplot(1,3,3)
scatter(initial_eff_F,t_upper,20,'vk','filled')
xlabel('Average Effective F-Statistic')
ylabel('95th Percentile of Size')
hline = refline([0 0.05]);
line([10 10],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])

figurename = strcat('figures/size_5_errorbar_t_effF',  '.eps')

%print(figurename,'-depsc')
%%
figure(3)
t_post_eff_F_mean=t_size_postF0_5;
t_post_eff_F_upper=quantile(t_size_postF_5,.95,2);
t_post_eff_F_lower=quantile(t_size_postF_5,.05,2);

fig=figure(3);
set(fig,'position',[0,0,700,230])
subplot(1,3,1)
scatter(initial_eff_F,t_post_eff_F_mean,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% t-Test, Screened on F')
hline = refline([0 0.05]);
line([10 10],[0 1],'Color','r');
ylim([0 1])
xlim([0 50])
subplot(1,3,2)
scatter(initial_eff_F,t_post_eff_F_lower,20,'^k','filled')
xlabel('Average Effective F-Statistic')
ylabel('5th Percentile of Size, Screened on F')
hline = refline([0 0.05]);
line([10 10],[0 1],'Color','r');
ylim([0 1])
xlim([0 50])
subplot(1,3,3)
scatter(initial_eff_F,t_post_eff_F_upper,20,'vk','filled')
xlabel('Average Effective F-Statistic')
ylabel('95th Percentile of Size, Screened on F')
hline = refline([0 0.05]);
line([10 10],[0 1],'Color','r');
ylim([0 1])
xlim([0 50])
 
figurename = strcat('figures/size_5_errorbar_t_posteffF',  '.eps')

%print(figurename,'-depsc')
%%
figure(4)
twostep_mean=twostep_size0_5;
twostep_upper=quantile(twostep_size_5,.95,2);
twostep_lower=quantile(twostep_size_5,.05,2);

fig=figure(4);
set(fig,'position',[0,0,700,230])
subplot(1,3,1)
scatter(initial_eff_F,twostep_mean,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test')
hline = refline([0 0.05]);
line([10 10],[0 .2],'Color','r');
ylim([0 .2])
xlim([0 50])
subplot(1,3,2)
scatter(initial_eff_F,twostep_lower,20,'^k','filled')
xlabel('Average Effective F-Statistic')
ylabel('5th Percentile of Two-Step Test')
hline = refline([0 0.05]);
line([10 10],[0 .2],'Color','r');
ylim([0 .2])
xlim([0 50])
subplot(1,3,3)
scatter(initial_eff_F,twostep_upper,20,'vk','filled')
xlabel('Average Effective F-Statistic')
ylabel('95th Percentile of Two-Step Test')
hline = refline([0 0.05]);
line([10 10],[0 .2],'Color','r');
ylim([0 .2])
xlim([0 50])
 
figurename = strcat('figures/size_5_errorbar_twostep',  '.eps')

%print(figurename,'-depsc')
%%
 
fig=figure(5);
set(fig,'position',[0,0,1200,400])
subplot(1,3,1)
scatter(initial_eff_F,twostep_size_eff_F5,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test with cutoff 5')
hline = refline([0 0.05]);
line([5 5],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])
subplot(1,3,2)
scatter(initial_eff_F,twostep_size_eff_F10,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test with cutoff 10')
hline = refline([0 0.05]);
line([10 10],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])
subplot(1,3,3)
scatter(initial_eff_F,twostep_size_eff_F15,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test with cutoff 15')
hline = refline([0 0.05]);
line([15 15],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])

figurename = strcat('figures/twostep_size_smallcrit_effF',  '.eps')

%print(figurename,'-depsc')
%%
 fig=figure(6);
set(fig,'position',[0,0,1200,400])
subplot(1,3,1)
scatter(initial_eff_F,twostep_size_eff_F20,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test with cutoff 20')
hline = refline([0 0.05]);
line([20 20],[0 .5],'Color','r');
ylim([0 0.5])
xlim([0 50])
subplot(1,3,2)
scatter(initial_eff_F,twostep_size_eff_F_crit5,20,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test with cutoff corr. to x=5')
hline = refline([0 0.05]);
ylim([0 0.5])
xlim([0 50])
subplot(1,3,3)
scatter(initial_eff_F,twostep_size_eff_F_crit10,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Two-Step Test with cutoff corr. to x=10')
hline = refline([0 0.05]);
ylim([0 0.5])
xlim([0 50])

figurename = strcat('figures/twostep_size_bigcrit_effF',  '.eps')

%print(figurename,'-depsc')
%% for overid test sizes
initial_eff_F(K_store==1)=[];
 J_size_store(K_store==1)=[];
 J_post_eff_F10_store(K_store==1)=[];
 share_F10_store(K_store==1)=[];
%%
fig=figure(7);
title('Overidentification Test')
%set(fig,'position',[0,0,400,400])
scatter(initial_eff_F,J_size_store,30,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Overidentification Test')
hline = refline([0 0.05]);
line([10 10],[0 0.5],'Color','r');
ylim([0 0.5])
xlim([0 50])

figurename = strcat('figures/overid_effF_beta2step',  '.eps')

%print(figurename,'-depsc')
 
%%
fig=figure(8);
title('Overidentification Test')
%set(fig,'position',[0,0,400,400])
scatter(initial_eff_F,J_post_eff_F10_store,30,'ob','filled')
xlabel('Average Effective F-Statistic')
ylabel('Size of 5% Overidentification Test, Screened on F')
hline = refline([0 0.05]);
line([10 10],[0 0.5],'Color','r');
ylim([0 0.5])
xlim([0 50])

figurename = strcat('figures/overid_posteffF_beta2step',  '.eps')
%print(figurename,'-depsc')
 
