
use hornung-data-textiles, clear

global firmlist 	ln_workers1802_all ln_looms1802_all ln_input1802_all no_looms imputed_dummy
global townlist 	ln_workers1802_all ln_looms1802_all ln_input1802_all no_looms ln_popcity1802 vieh1816_schaf_ganz_veredelt_pc imputed_dummy
global xlist    	ln_workers1802_all ln_looms1802_all ln_input1802_all no_looms ln_popcity1802 vieh1816_schaf_ganz_veredelt_pc pop1816_prot_pc no_hugue_possible imputed_dummy
global mixlist 		ln_workers1802_all ln_looms1802_all mi_ln_input1802_all no_looms ln_popcity1802 vieh1816_schaf_ganz_veredelt_pc pop1816_prot_pc no_hugue_possible imputed_dummy
global mixlistp 	ln_workers1802_all ln_looms1802_all mi_ln_input1802_all no_looms ln_popcity1802 vieh1816_schaf_ganz_veredelt_pc no_hugue_possible imputed_dummy
global vamixlist 	ln_workers1802_all ln_looms1802_all no_looms ln_popcity1802 vieh1816_schaf_ganz_veredelt_pc pop1816_prot_pc no_hugue_possible imputed_dummy
global lomixlist 	ln_workers1802_all ln_output1802_all no_looms ln_popcity1802 vieh1816_schaf_ganz_veredelt_pc pop1816_prot_pc no_hugue_possible

***
capture program drop output_tables
program output_tables
	args  exog1 exogp specid 
{
	
	global exog1 "`exog1'"
	global exogp "`exogp'"
	local b_fs_start = colnumb(suestb,"fs_mean:$exog1")
	local b_fs_end = colnumb(suestb,"fs_mean:$exogp")
	local b_rf_start = colnumb(suestb,"rf_mean:$exog1")
	local b_rf_end = colnumb(suestb,"rf_mean:$exogp")

	local vcov_fs_start = colnumb(suestV,"fs_mean:$exog1")
	local vcov_fs_end = colnumb(suestV,"fs_mean:$exogp")
	local vcov_rf_start = colnumb(suestV,"rf_mean:$exog1")
	local vcov_rf_end = colnumb(suestV,"rf_mean:$exogp")

	mat b_fs = suestb[1,`b_fs_start'..`b_fs_end']
	mat vcov_fs = suestV[`vcov_fs_start'..`vcov_fs_end',`vcov_fs_start'..`vcov_fs_end']
	mat b_rf = suestb[1,`b_rf_start'..`b_rf_end']
	mat vcov_rf = suestV[`vcov_rf_start'..`vcov_rf_end',`vcov_rf_start'..`vcov_rf_end']
	mat vcov_rf_fs = suestV[`vcov_rf_start'..`vcov_rf_end',`vcov_fs_start'..`vcov_fs_end']

	mat b = b_fs, b_rf
	mat list b // these would match the equation-by-equation regression results.
	mat2txt, matrix(b) saving(b_`specid') replace  // export with specification id

	mat vcov = vcov_fs, vcov_rf_fs' \ vcov_rf_fs , vcov_rf
	mat list vcov // these would match the equation-by-equation regression results.
	mat2txt, matrix(vcov) saving(vcov_`specid')  replace
 
}
end

*** Table 4: Instrumenting the Huguenot Population Share with Population Losses during the Thirty Years' War, Part 1
estimates clear
* first-stage
reg hugue_1700_pc poploss_keyser $mixlist textil_1680_dummy
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:hugue_1700_pc poploss_keyser $mixlist textil_1680_dummy) (rf_mean: ln_output1802_all poploss_keyser $mixlist textil_1680_dummy )
mat suestb = e(b)
mat suestV = e(V) * $dof
output_tables "poploss_keyser" "poploss_keyser" 241
mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 
 
estimates clear
* first-stage
reg hugue_1700_pc poploss_keyser_projected $mixlist textil_1680_dummy

global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:hugue_1700_pc poploss_keyser_projected $mixlist textil_1680_dummy) (rf_mean: ln_output1802_all poploss_keyser_projected $mixlist textil_1680_dummy)

mat suestb = e(b)
mat suestV = e(V) * $dof

output_tables "poploss_keyser_projected" "poploss_keyser_projected" 242 

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 
*** Table 5: Instrumenting the Huguenot Population Share with Population Losses during the Thirty Years' War, Part 2
estimates clear
* first-stage
reg hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy 

global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy ) (rf_mean: ln_output1802_all  poploss_aggregated_pr $mixlist textil_1680_dummy )

mat suestb = e(b)
mat suestV = e(V) * $dof

output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 243

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 
*Table 5 (5) spec id 244
 estimates clear
* first-stage
reg ln_occ1700_hugue_textile poploss_aggregated_pr $mixlist textil_1680_dummy 

global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:ln_occ1700_hugue_textile poploss_aggregated_pr $mixlist textil_1680_dummy ) (rf_mean: ln_output1802_all poploss_aggregated_pr $mixlist textil_1680_dummy)

mat suestb = e(b)
mat suestV = e(V) * $dof

output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 244

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 
*** Table 6: Robustness Tests
 

*** Panel C
*Table 6 (1) spec id 245
 estimates clear
* first-stage
reg hugue_1700_pc poploss_aggregated_pr $mixlistp textil_1680_dummy rel1816_protluth_pc rel1816_protref_pc if poploss_aggregated_pr!=. 
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:hugue_1700_pc poploss_aggregated_pr $mixlistp textil_1680_dummy rel1816_protluth_pc rel1816_protref_pc) ///
	(rf_mean: ln_output1802_all  poploss_aggregated_pr  $mixlistp textil_1680_dummy rel1816_protluth_pc rel1816_protref_pc ) if poploss_aggregated_pr!=. 

mat suestb = e(b)
mat suestV = e(V) * $dof

output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 245

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 **Table 6 (2) spec id 246

 estimates clear
* first-stage
reg  hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy ln_piece_value if poploss_aggregated_pr!=.
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy ln_piece_value) ///
	(rf_mean: ln_output1802_all  poploss_aggregated_pr  $mixlist textil_1680_dummy ln_piece_value   ) if poploss_aggregated_pr!=. 

mat suestb = e(b)
mat suestV = e(V) * $dof

output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 246

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 



***Table 6 (3) spec id 247

 estimates clear
* first-stage
reg  hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy hats-posament if poploss_aggregated_pr!=.
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean: hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy hats-posament) ///
	(rf_mean: ln_output1802_all  poploss_aggregated_pr $mixlist textil_1680_dummy hats-posament  ) if poploss_aggregated_pr!=. 
mat suestb = e(b)
mat suestV = e(V) * $dof
 
output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 247

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result
 
*Table 6 (4) spec if 248 
 estimates clear
* first-stage
reg  hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy if looms1802_all!=0 & poploss_aggregated_pr!=.
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:  hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy) ///
	(rf_mean: ln_output1802_all  poploss_aggregated_pr $mixlist textil_1680_dummy  ) if looms1802_all!=0 & poploss_aggregated_pr!=. 
mat suestb = e(b)
mat suestV = e(V) * $dof
output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 248

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result // these would match the equation-by-equation regression results.
 
*able 6 (5) spec if 249
 estimates clear
* first-stage
reg  hugue_1700_pc poploss_aggregated_pr  $mixlist textil_1680_dummy if workers1802_all>=16 & poploss_aggregated_pr!=.
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:  hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy) ///
	(rf_mean: ln_output1802_all  poploss_aggregated_pr $mixlist textil_1680_dummy  ) if workers1802_all>=16 & poploss_aggregated_pr!=. 
mat suestb = e(b)
mat suestV = e(V) * $dof
output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 249

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result // these would match the equation-by-equation regression results.
 

preserve
collapse (mean) ln_output1802_all hugue_1700_pc $mixlist poploss_aggregated_pr textil_1680_dummy, by (groupid)
ivreg2 ln_output1802_all (hugue_1700_pc=poploss_aggregated_pr) $mixlist textil_1680_dummy if poploss_aggregated_pr!=., r
*Table 6 (6) spec id 250
 estimates clear
* first-stage
reg   hugue_1700_pc poploss_aggregated_pr  $mixlist textil_1680_dummy if poploss_aggregated_pr!=.
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean:  hugue_1700_pc poploss_aggregated_pr $mixlist textil_1680_dummy) ///
	(rf_mean: ln_output1802_all  poploss_aggregated_pr $mixlist textil_1680_dummy  ) if poploss_aggregated_pr!=. 
mat suestb = e(b)
mat suestV = e(V) * $dof
output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 250

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result // these would match the equation-by-equation regression results.
restore
 *Table 6 (7) spec id 251

 estimates clear
* first-stage
reg  hugue_1700_pc poploss_aggregated_pr  $vamixlist textil_1680_dummy if poploss_aggregated_pr!=.
global N = e(N)
global K = e(N)- e(df_r)
global dof = (e(N))/e(df_r) // (N)/(N-K)  to match dof adj in sureg
 
sureg (fs_mean: hugue_1700_pc poploss_aggregated_pr  $vamixlist textil_1680_dummy ) ///
	(rf_mean: mi_ln_value_added  poploss_aggregated_pr  $vamixlist textil_1680_dummy  ) if   poploss_aggregated_pr!=. 
mat suestb = e(b)
mat suestV = e(V) * $dof
output_tables "poploss_aggregated_pr" "poploss_aggregated_pr" 251

mat result = b_fs, vcov_fs,b_rf,vcov_rf,vcov_rf_fs
mat list result // these would match the equation-by-equation regression results.
 
