function results = simulation_bayes(D,s,k,specid,beta_null,pi,delta,Sigma_pi,Sigma_delta,Sigma_delta_pi,zz,eff_f_crit)
disp(specid)
%% simulate pi and delta

rng(6);  % For reproducibility
j = nan(D,1);
q = nan(D,1);
l = nan(D,1);
a = nan(D,1); 
b = nan(D,1);
c = nan(D,1);
d = nan(D,1);
e = nan(D,1);
f = nan(D,1);
m = nan(D,1);
n = nan(D,1);
o = nan(D,1);
g = nan(D,1);
r = nan(D,1);
h = nan(D,1);
i = nan(D,1);
u = nan(D,1);
    %% initial first-stage effective  F
if k > 1 
    Sigma_zv = zz*Sigma_pi;
    initial_eff_f= pi*zz*pi'/trace(Sigma_zv);
else  
    Sigma_zv = [];
    initial_eff_f=pi*Sigma_pi^-1*pi';
end   
    i(1)=initial_eff_f;
%% draw according to hyperparameters
mu = [delta,pi];
Sigma = [Sigma_delta, Sigma_delta_pi ; Sigma_delta_pi', Sigma_pi];
R = mvnrnd(mu, Sigma,D);
%% adjust delta
pi_d = R(:,(k+1):2*k);
delta_d = R(:,1:k);
beta_d = diag(pi_d*zz*pi_d').^-1.*diag(pi_d*zz*delta_d'); 
delta_tilde_d = beta_d.*pi_d;
%%
parfor dd=1:D
    disp(dd)
    pi_tilde = pi_d(dd,:);
    delta_tilde = delta_tilde_d(dd,:);
    beta_tilde = beta_d(dd);
    mu_tilde = [delta_tilde,pi_tilde];
    R = mvnrnd(mu_tilde, Sigma,s);
    %%  calculate first stage f
    pi_s = R(:,(k+1):2*k);

%%  calculate first stage effective f based on draws
 
if k > 1 
    first_eff_f = diag(pi_s*zz*pi_s')/trace(Sigma_zv);

else  
    first_eff_f = diag(pi_s*Sigma_pi^-1*pi_s');
end    
 
if k > 1 
     eff_k_5 = round( (trace(Sigma_zv)^2*(1+2*5))/(trace(Sigma_zv*Sigma_zv)+2*5*trace(Sigma_zv)*eigs(Sigma_zv,1)));
     eff_k_10 =round( (trace(Sigma_zv)^2*(1+2*10))/(trace(Sigma_zv*Sigma_zv)+2*10*trace(Sigma_zv)*eigs(Sigma_zv,1)));

else  
     eff_k_5 = 1;
     eff_k_10 = 1;
end 

if eff_k_5 < 30
    eff_f_crit_5=eff_f_crit((eff_f_crit(:,1)==eff_k_5),3);
else
    eff_f_crit_5=eff_f_crit((eff_f_crit(:,1)==30),3);
end

if eff_k_10 < 30
    eff_f_crit_10=eff_f_crit((eff_f_crit(:,1)==eff_k_10),4);
else
    eff_f_crit_10=eff_f_crit((eff_f_crit(:,1)==30),4);
end
    %%  calculate beta, variance of beta (by MD method)

    delta_s = R(:,1:k);
    beta_s = diag(pi_s*zz*pi_s').^-1.*diag(pi_s*zz*delta_s'); 

    nabla=[(diag(pi_s*zz*pi_s').^-1*ones(1,k)).*(pi_s*zz) ,  -(diag(pi_s*zz*pi_s').^-2*ones(1,k)).*(diag(pi_s*zz*delta_s')*ones(1,k)).*(pi_s*zz)];
 
    Sigma_beta_s = diag(nabla*Sigma*nabla');

    %% simulat t statistic and AR statistic
    t = (beta_s-beta_tilde) ./(Sigma_beta_s.^0.5);  
    ar = diag((delta_s-pi_s*beta_tilde)*inv(Sigma_delta-beta_tilde*Sigma_delta_pi-beta_tilde*Sigma_delta_pi'+beta_tilde^2*Sigma_pi)*(delta_s-pi_s*beta_tilde)');

    %% calculate sizes for t test
    j(dd)=sum(abs(t)>1.64)/s; % 10% level
    q(dd)=sum(abs(t)>1.96)/s; % 5% level
    l(dd)=sum(abs(t)>2.58)/s; % 1% level

    %% calculate sizes for screening on the first-stage effective F
    a_eff_F10(dd)=sum(abs(t(first_eff_f>10))>1.64)/sum(first_eff_f>10); % 10% level
    b_eff_F10(dd)=sum(abs(t(first_eff_f>10))>1.96)/sum(first_eff_f>10); % 5% level
    c_eff_F10(dd)=sum(abs(t(first_eff_f>10))>2.58)/sum(first_eff_f>10); % 1% level

    %% calculate sizes for two-step test and cutoff (5,10,15,25,crit5,crit10)
    d_eff_F5(dd)=(sum(abs(t(first_eff_f>5))>1.64) + sum(ar(first_eff_f<=5)>chi2inv(0.9,k)))/s;
    e_eff_F5(dd)=(sum(abs(t(first_eff_f>5))>1.96) + sum(ar(first_eff_f<=5)>chi2inv(0.95,k)))/s;
    f_eff_F5(dd)=(sum(abs(t(first_eff_f>5))>2.58) + sum(ar(first_eff_f<=5)>chi2inv(0.99,k)))/s;

    d_eff_F10(dd)=(sum(abs(t(first_eff_f>10))>1.64) + sum(ar(first_eff_f<=10)>chi2inv(0.9,k)))/s;
    e_eff_F10(dd)=(sum(abs(t(first_eff_f>10))>1.96) + sum(ar(first_eff_f<=10)>chi2inv(0.95,k)))/s;
    f_eff_F10(dd)=(sum(abs(t(first_eff_f>10))>2.58) + sum(ar(first_eff_f<=10)>chi2inv(0.99,k)))/s;
    
    d_eff_F15(dd)=(sum(abs(t(first_eff_f>15))>1.64) + sum(ar(first_eff_f<=15)>chi2inv(0.9,k)))/s;
    e_eff_F15(dd)=(sum(abs(t(first_eff_f>15))>1.96) + sum(ar(first_eff_f<=15)>chi2inv(0.95,k)))/s;
    f_eff_F15(dd)=(sum(abs(t(first_eff_f>15))>2.58) + sum(ar(first_eff_f<=15)>chi2inv(0.99,k)))/s;
    
    d_eff_F20(dd)=(sum(abs(t(first_eff_f>20))>1.64) + sum(ar(first_eff_f<=20)>chi2inv(0.9,k)))/s;
    e_eff_F20(dd)=(sum(abs(t(first_eff_f>20))>1.96) + sum(ar(first_eff_f<=20)>chi2inv(0.95,k)))/s;
    f_eff_F20(dd)=(sum(abs(t(first_eff_f>20))>2.58) + sum(ar(first_eff_f<=20)>chi2inv(0.99,k)))/s;
    
    d_eff_F_crit5(dd)=(sum(abs(t(first_eff_f>eff_f_crit_5))>1.64) + sum(ar(first_eff_f>eff_f_crit_5)>chi2inv(0.9,k)))/s;
    e_eff_F_crit5(dd)=(sum(abs(t(first_eff_f>eff_f_crit_5))>1.96) + sum(ar(first_eff_f>eff_f_crit_5)>chi2inv(0.95,k)))/s;
    f_eff_F_crit5(dd)=(sum(abs(t(first_eff_f>eff_f_crit_5))>2.58) + sum(ar(first_eff_f>eff_f_crit_5)>chi2inv(0.99,k)))/s;
 
    d_eff_F_crit10(dd)=(sum(abs(t(first_eff_f>eff_f_crit_10))>1.64) + sum(ar(first_eff_f>eff_f_crit_10)>chi2inv(0.9,k)))/s;
    e_eff_F_crit10(dd)=(sum(abs(t(first_eff_f>eff_f_crit_10))>1.96) + sum(ar(first_eff_f>eff_f_crit_10)>chi2inv(0.95,k)))/s;
    f_eff_F_crit10(dd)=(sum(abs(t(first_eff_f>eff_f_crit_10))>2.58) + sum(ar(first_eff_f>eff_f_crit_10)>chi2inv(0.99,k)))/s;
%% calculate sizes for ar test
    m(dd)=sum(ar >chi2inv(0.9,k))/s;
    n(dd)=sum(ar >chi2inv(0.95,k))/s;
    o(dd)=sum(ar >chi2inv(0.99,k))/s;


    %% median bias of beta_s and t stat
    h(dd)=median(beta_s)-beta_tilde;
    u(dd)=median(t);

    
        %% frequency with which F>10 and mean F
    g(dd)=sum(first_eff_f>10)/s;
    r(dd) = mean(first_eff_f);

end


    %% output results
matname=strcat('simulation_eff_F/spec', specid);
save(matname,'beta_d','delta_d','pi_d',...
    'j','q','l','a_eff_F10','b_eff_F10','c_eff_F10','d_eff_F5','e_eff_F5','f_eff_F5',...
    'd_eff_F10','e_eff_F10','f_eff_F10','d_eff_F15','e_eff_F15','f_eff_F15',...
    'd_eff_F20','e_eff_F20','f_eff_F20',...
    'd_eff_F_crit5','e_eff_F_crit5','f_eff_F_crit5', 'd_eff_F_crit10','e_eff_F_crit10','f_eff_F_crit10',...
    'm','n','o','g','r','h','u','i','-append');

end
