function results = simulation_overid(s,k,specid,beta_null,pi,delta,Sigma_pi,Sigma_delta,Sigma_delta_pi,zz)
disp(specid)
%% simulate pi and delta according to estimates based on the data
delta_tilde  = beta_null*pi; % adjust delta so that the 2sls estimate beta is beta_null

mu = [delta_tilde,pi];
Sigma = [Sigma_delta, Sigma_delta_pi ; Sigma_delta_pi', Sigma_pi];
    Sigma_zv = zz*Sigma_pi;
    
    rng(6);  % For reproducibility
    R = mvnrnd(mu, Sigma,s);
    pi_s = R(:,(k+1):2*k);

    delta_s = R(:,1:k);
    beta_s = diag(pi_s*zz*pi_s').^-1.*diag(pi_s*zz*delta_s');
    %%  calculate \hat\beta_2sls and J statistic
 
    J_store = zeros(s,1);
    parfor S = 1:s
        omega = Sigma_delta-beta_s(S)*(Sigma_delta_pi+Sigma_delta_pi')+beta_s(S)^2*Sigma_pi;
        omega_inv = inv(omega)
        beta_2step =  (pi_s(S,:)*omega_inv*pi_s(S,:)')^-1.*(pi_s(S,:)*omega_inv*delta_s(S,:)');
        omega_2step = Sigma_delta-beta_2step*(Sigma_delta_pi+Sigma_delta_pi')+beta_2step^2*Sigma_pi;
 
        J_store(S) = (delta_s(S,:)-pi_s(S,:)*beta_2step)*inv(omega_2step)*((delta_s(S,:)-pi_s(S,:)*beta_2step)');

    end
    %% calculate sizes for J
    
    J_size=mean(J_store>chi2inv(0.95,k-1));

    first_eff_f = diag(pi_s*zz*pi_s')/trace(Sigma_zv);
    J_post_eff_F10=mean(J_store(first_eff_f>10)>chi2inv(0.95,k-1));  

    share_F10 = mean(first_eff_f>10);
  
    %% output results
matname=strcat('./simulation_eff_F/spec', specid);
save(matname,'J_size','J_post_eff_F10','share_F10','-append');
 
 end
